package com.jiuqi.util;

import java.util.Arrays;
import java.util.Random;

/* loaded from: com_jiuqi_util.jar:com/jiuqi/util/Base64.class */
public class Base64 {
    private static final char[] intToBase64 = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'};
    private static final char[] intToAltBase64 = {'!', '\"', '#', '$', '%', '&', '\'', '(', ')', ',', '-', '.', ':', ';', '<', '>', '@', '[', ']', '^', '`', '_', '{', '|', '}', '~', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '?'};
    private static final byte[] base64ToInt = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51};
    private static final byte[] altBase64ToInt = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, -1, 62, 9, 10, 11, -1, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 12, 13, 14, -1, 15, 63, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 17, -1, 18, 19, 21, 20, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 22, 23, 24, 25};

    public static String byteArrayToBase64(byte[] a) {
        return byteArrayToBase64(a, false);
    }

    static String byteArrayToAltBase64(byte[] a) {
        return byteArrayToBase64(a, true);
    }

    public static String byteArrayToBase64(byte[] a, boolean alternate) {
        if (a == null) {
            return null;
        }
        if (a.length == 0) {
            return "";
        }
        int aLen = a.length;
        int numFullGroups = aLen / 3;
        int numBytesInPartialGroup = aLen - (3 * numFullGroups);
        int resultLen = 4 * ((aLen + 2) / 3);
        StringBuffer result = new StringBuffer(resultLen);
        char[] intToAlpha = alternate ? intToAltBase64 : intToBase64;
        int inCursor = 0;
        for (int i = 0; i < numFullGroups; i++) {
            int i2 = inCursor;
            int inCursor2 = inCursor + 1;
            int byte0 = a[i2] & 255;
            int inCursor3 = inCursor2 + 1;
            int byte1 = a[inCursor2] & 255;
            inCursor = inCursor3 + 1;
            int byte2 = a[inCursor3] & 255;
            result.append(intToAlpha[byte0 >> 2]);
            result.append(intToAlpha[((byte0 << 4) & 63) | (byte1 >> 4)]);
            result.append(intToAlpha[((byte1 << 2) & 63) | (byte2 >> 6)]);
            result.append(intToAlpha[byte2 & 63]);
        }
        if (numBytesInPartialGroup != 0) {
            int i3 = inCursor;
            int inCursor4 = inCursor + 1;
            int byte02 = a[i3] & 255;
            result.append(intToAlpha[byte02 >> 2]);
            if (numBytesInPartialGroup == 1) {
                result.append(intToAlpha[(byte02 << 4) & 63]);
                result.append("==");
            } else {
                int i4 = inCursor4 + 1;
                int byte12 = a[inCursor4] & 255;
                result.append(intToAlpha[((byte02 << 4) & 63) | (byte12 >> 4)]);
                result.append(intToAlpha[(byte12 << 2) & 63]);
                result.append('=');
            }
        }
        return result.toString();
    }

    public static byte[] base64ToByteArray(String s) {
        return base64ToByteArray(s, false);
    }

    static byte[] altBase64ToByteArray(String s) {
        return base64ToByteArray(s, true);
    }

    public static byte[] base64ToByteArray(String s, boolean alternate) {
        if (s == null) {
            return null;
        }
        if (s.length() == 0) {
            return new byte[0];
        }
        String s2 = StringUtils.replace(StringUtils.replace(s, "\n", ""), "\r", "");
        byte[] alphaToInt = alternate ? altBase64ToInt : base64ToInt;
        int sLen = s2.length();
        int numGroups = sLen / 4;
        if (4 * numGroups != sLen) {
            throw new IllegalArgumentException("String length must be a multiple of four.");
        }
        int missingBytesInLastGroup = 0;
        int numFullGroups = numGroups;
        if (sLen != 0) {
            if (s2.charAt(sLen - 1) == '=') {
                missingBytesInLastGroup = 0 + 1;
                numFullGroups--;
            }
            if (s2.charAt(sLen - 2) == '=') {
                missingBytesInLastGroup++;
            }
        }
        byte[] result = new byte[(3 * numGroups) - missingBytesInLastGroup];
        int inCursor = 0;
        int outCursor = 0;
        for (int i = 0; i < numFullGroups; i++) {
            int i2 = inCursor;
            int inCursor2 = inCursor + 1;
            int ch0 = base64toInt(s2.charAt(i2), alphaToInt);
            int inCursor3 = inCursor2 + 1;
            int ch1 = base64toInt(s2.charAt(inCursor2), alphaToInt);
            int inCursor4 = inCursor3 + 1;
            int ch2 = base64toInt(s2.charAt(inCursor3), alphaToInt);
            inCursor = inCursor4 + 1;
            int ch3 = base64toInt(s2.charAt(inCursor4), alphaToInt);
            int i3 = outCursor;
            int outCursor2 = outCursor + 1;
            result[i3] = (byte) ((ch0 << 2) | (ch1 >> 4));
            int outCursor3 = outCursor2 + 1;
            result[outCursor2] = (byte) ((ch1 << 4) | (ch2 >> 2));
            outCursor = outCursor3 + 1;
            result[outCursor3] = (byte) ((ch2 << 6) | ch3);
        }
        if (missingBytesInLastGroup != 0) {
            int i4 = inCursor;
            int inCursor5 = inCursor + 1;
            int ch02 = base64toInt(s2.charAt(i4), alphaToInt);
            int inCursor6 = inCursor5 + 1;
            int ch12 = base64toInt(s2.charAt(inCursor5), alphaToInt);
            int i5 = outCursor;
            int outCursor4 = outCursor + 1;
            result[i5] = (byte) ((ch02 << 2) | (ch12 >> 4));
            if (missingBytesInLastGroup == 1) {
                int i6 = inCursor6 + 1;
                int i7 = outCursor4 + 1;
                result[outCursor4] = (byte) ((ch12 << 4) | (base64toInt(s2.charAt(inCursor6), alphaToInt) >> 2));
            }
        }
        return result;
    }

    private static int base64toInt(char c, byte[] alphaToInt) {
        byte b = alphaToInt[c];
        if (b < 0) {
            throw new IllegalArgumentException("Illegal character " + c);
        }
        return b;
    }

    public static void main(String[] args) {
        int numRuns = Integer.parseInt(args[0]);
        int numBytes = Integer.parseInt(args[1]);
        Random rnd = new Random();
        for (int i = 0; i < numRuns; i++) {
            for (int j = 0; j < numBytes; j++) {
                byte[] arr = new byte[j];
                for (int k = 0; k < j; k++) {
                    arr[k] = (byte) rnd.nextInt();
                }
                String s = byteArrayToBase64(arr);
                byte[] b = base64ToByteArray(s);
                if (!Arrays.equals(arr, b)) {
                    System.out.println("Dismal failure!");
                }
                String s2 = byteArrayToAltBase64(arr);
                byte[] b2 = altBase64ToByteArray(s2);
                if (!Arrays.equals(arr, b2)) {
                    System.out.println("Alternate dismal failure!");
                }
            }
        }
    }
}
